/***************************************************************************
 *   Copyright (C) 1998-2007 by authors (see AUTHORS.txt )                 *
 *                                                                         *
 *   This file is part of Lux Renderer.                                    *
 *                                                                         *
 *   Lux Renderer is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Lux Renderer is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 *   This project is based on PBRT ; see http://www.pbrt.org               *
 *   Lux Renderer website : http://www.luxrender.org                       *
 ***************************************************************************/  

// regular.cpp*
#include "regular.h"
#include "memory.h"

using namespace lux;

void RegularSPD::init(float lMin, float lMax, const float* const s, int n) {
  lambdaMin = lMin;
  lambdaMax = lMax;
  delta = (lambdaMax - lambdaMin) / (n-1);
  invDelta = 1.f / delta;
  nSamples = n;

  AllocateSamples(n);

  // Copy samples
  for (int i = 0; i < n; i++)
    samples[i] = s[i];

  Clamp();
}

